{{
*****************************************
* Spin waitcnt based pwm pulse generator*
* Author: TJ Johnson                    *                 
*****************************************
}}
CON
  _CLKMODE      = XTAL1 + PLL16X                        
  _XINFREQ      = 5_000_000

pin1 = 0
pin2 = 1


Obj

oled : "Uoled-128-gmd1"


Var

long start 
long freqon
long freqoff
long Ondelay
long internaldutytime
long dutycount
long data
long cog
long stack1[50]    
long TotalTime 

pub testrun
'Start this thing up, running at 10khz, 50% duty, with 10 segments created by the second pin, delayed 10% from pin1's on time.
run( 10_000, 50, 10, 10)


Pub run (freq, mainduty, smallduty, ondelaypercent)  
' totaltime = clkfreq/freq
' freqon = duty/100 * totaltime
' freqoff = (100-duty)/100 * totaltime
' smallduty = totaltime/smallduty
' ondelay = freqon *ondelaypercent/100

 

cognew(screen,@stack1)  
totaltime := clkfreq/freq
freqon := (totaltime*mainduty)/100
freqoff := ( totaltime*(100-mainduty) ) /100
ondelay := (ondelaypercent*freqon)/100
internaldutytime := (freqon-ondelay)/ smallduty
dutycount := smallduty
dutycount := smallduty
 

  waitcnt(clkfreq*3 +cnt)  ' Wait for the screen to start up. 
  
  cognew(@entry, @start)
repeat
  waitcnt(clkfreq+cnt)      
  

pub Update(freq, mainduty, smallduty, ondelaypercent)     ' Not yet implemented into the asm side. 
totaltime := clkfreq/freq
freqon := (totaltime*mainduty)/100
freqoff := ( totaltime*(100-mainduty) ) /100
ondelay := (ondelaypercent*freqon)/100
internaldutytime := (freqon-ondelay)/ smallduty
dutycount := smallduty
data := 1
repeat until data <> 1
return true   
pub screen   
  oled.init  
waitcnt(clkfreq +cnt)  
   

repeat  
  
  oled.erase
  oled.FTEXT(0,0, 1, 255,255,255,String("totaltime") , 0) 
  oled.FTEXT(0,1, 1, 255,255,255,( totaltime  ) , 1)

  oled.FTEXT(0,2, 1, 255,255,255,String("freqon") , 0) 
  oled.FTEXT(0,3, 1, 255,255,255,( freqon  ) , 1)

  oled.FTEXT(0,4, 1, 255,255,255,String("freqoff") , 0) 
  oled.FTEXT(0,5, 1, 255,255,255,( freqoff  ) , 1)

  oled.FTEXT(0,6, 1, 255,255,255,String("ondelay") , 0) 
  oled.FTEXT(0,7, 1, 255,255,255,( ondelay ) , 1)

  oled.FTEXT(0,8, 1, 255,255,255,String("internaldutytime") , 0) 
  oled.FTEXT(0,9, 1, 255,255,255,( internaldutytime  ) , 1)

  oled.FTEXT(0,10, 1, 255,255,255,String("dutycount") , 0) 
  oled.FTEXT(0,11, 1, 255,255,255,( dutycount  ) , 1)
  
  waitcnt(clkfreq + cnt) 



Dat

  org 
entry   mov     location, par                'get first location
        add location, #4                          ' Move 1 increment long
 
        
        wrlong freqonloc, location                  ' Store adress of freq in freqloc
        add location, #4                          ' move another loc long 
        
        wrlong freqoffloc, location                  ' Store adress of freq in freqloc
        add location, #4

        
        wrlong ondelayloc, location               ' ondelay location
        add location, #4                          'Move 1 long

        wrlong internaldutytimeloc, location          ' internal duty location
        add location, #4

        wrlong dutycountloc, location                   ' the number of times to cut up the small loop. 
        add location, #4
        
        or dira, mask1                              'set pins output
        or dira, mask2                                        

        

:dataup  rdlong freqon1, freqonloc                    'store data  
        rdlong freqoff1, freqoffloc
        rdlong ondelay1, ondelayloc
        rdlong internaldutytime1, internaldutytimeloc
        rdlong dutycount1, dutycountloc
    
        
        
          ' rdlong dataupdated, location                    ' check dataupdate
      '  tjnz dataupdated, dataup                        ' if not 0, jump to dataup

:loop    andn outa , mask1                                 ' turn off Pin1 and pin2
        andn outa, mask2
        mov time, cnt                                ' Wait low side of pulse
        waitcnt time, freqoff1

        or outa, mask1                                 ' Turn on pin1

        wrlong loopcount, dutycount1                      ' Set loopcount to the small duty count

        mov time, cnt                                      'Wait for the on delay %
        waitcnt time, ondelay1 
        
                     
                       
:onloop or outa, mask2                   ' pin 2 on

        mov time, cnt
        waitcnt time, internaldutytime1       ' Waitcnt small segment loop 

        andn outa, mask2                     'pin 2 off

        mov time, cnt
        waitcnt time, internaldutytime1       ' Waitcnt small segment loop
        
        sub loopcount, #2                     'subtract 1 from loopcount     
        tjz loopcount, #:loop                  ' Jump to main loop if loopcount = 0

        jmp #:onloop                           ' go back to onloop if we havent finished our on time. 
        
     



  

mask1 long |< pin1                  
mask2 long |< pin2

dataupdated             res 1
location                res 1                    
freqonloc               res 1
freqoffloc              res 1
ondelayloc              res 1
internaldutytimeloc     res 1
dutycountloc            res 1
time                    res 1


freqon1                 res 1
freqoff1                res 1
ondelay1                res 1
internaldutytime1       res 1
dutycount1              res 1
loopcount               res 1



{
               OR      OUTA,bitmask   ' This turns the pin on

               ANDN OUTA,bitmask   ' This turns the pin off

bitmask   LONG   |< 16              ' Have a single bit turned on (1).  The rest are zeroes.}     